/*
 xmmglue

   Authors:  Aitor Ibarra - XMM-Newton SOC (ESAC/ESA)
         
   Description: Glue different rgs exposures
 
   Comments: 
 
  $Id: module.cc,v 1.5 2000/10/02 08:30:13 gvacanti Exp $
*/

#include "xmmglue.h"
#include "CalOalUtility.h"
#include "STime.h"

#include <Tracer.h>
#include <errstr.h>
#include <Dal.h>

#include <vector>

void xmmglue ()
{
PROC

	vector<string> pfhfiles = stringListParameter("filelist");
		
	DataSet*  rgsOriginalDS = dataSetServer->open(stringParameter("firstfile"), Dal::Read);
    //Table* oriTable = rgsOriginalDS->table("R2PFH1");
    Table* oriTable = rgsOriginalDS->table(0,Dal::Read);
    cout << "number of columns " << oriTable->columns() << endl;

	/*
	 * Calculate the exact number of rows 
	 */
 	int finalRows=oriTable->rows();
 	 
	for (unsigned int l = 0 ; l < pfhfiles.size() ; l++)
	{				
			std::cout << "files " << pfhfiles[l] << endl;
			DataSet*  rgsTempDS = dataSetServer->open(pfhfiles[l], Dal::Read);
			finalRows = finalRows +rgsTempDS->table(0,Dal::Read)->rows();
			dataSetServer->close(rgsTempDS);
	}				

	/*
     * New file 
     */
    DataSet*  newDS = dataSetServer->open("test1.dat", Dal::Create); 	    
    //Table *tab = 0;
	cout << "Adding the Table... "  << endl;		
	Table *tab = newDS->addTable(oriTable->name(),finalRows);						

    /*
     * I need to know the number of rows!!!
     */
	
	
	string obsEndAttr;

    				
	for (unsigned int i = 0 ; i < oriTable->columns() ; i++)
	{
		int counter=0;
		vector<string> stringVec;	
		string stringMax=" ";	
		longVec lv(1);		
				
		uint16 *uint16Dat=0;
		uint32 *uint32Dat=0;		
		int8 *int8Dat=0;
		real32 *real32Dat=0;
		real64 *real64Dat=0;
		int16 *int16Dat=0;
		int32 *int32Dat=0;
		
		Column *colTest=0;
		ColumnData *testData = 0;     
	
		Column *col = oriTable->column(i,Column::Modify);
		ColumnData *colData = col->data();

		for (unsigned int l = 0 ; l < pfhfiles.size() ; l++)
		{				
			std::cout << "files " << pfhfiles[l] << endl;
			DataSet*  rgsTempDS = dataSetServer->open(pfhfiles[l], Dal::Read);
			//Table* tempTable = rgsTempDS->table("R2PFH1");
			Table* tempTable = rgsTempDS->table(0,Dal::Read);								
	
			Column *col2 = tempTable->column(i,Column::Read);
			ColumnData *col2Data = col2->data();
			
			switch( col -> dataType() )
			{
				case Column::Bool :
					cout << "bool " << endl;
					exit(1);
	    		break;
				case Column::Int8  :
					cout << "Int8 " << endl;
					
					if (l==0)
					{						
						counter=0;
						colTest = tab->addColumn(col->name(), Column::Int8,"int8 data","");
						testData = colTest->data();
						int8Dat =  testData->int8Data();
						cout << "Column " << col->name() << " added" << endl;
					}
				
					if (l==0)
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{    				    				
							int8Dat[counter]= colData->int8Data()[j];
							counter++;
						}	    					    			
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{
						int8Dat[counter]= col2Data->int8Data()[j];
						counter++;
					}
				    		   									
	    		break;
				case Column::Uint16 :
					cout << "Uint16 " << endl;
					
					if (l == 0)
					{
						counter=0;
						colTest = tab->addColumn(col->name(), Column::Uint16,"uint data","");
						testData = colTest->data();
						uint16Dat =  testData->uint16Data();
						cout << "Column " << col->name() << " added" << endl;	
					}
					
					if (l == 0)
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{    				    				
							uint16Dat[counter] = colData->uint16Data()[j];
							counter++;
						}
				
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{
						uint16Dat[counter] = col2Data->uint16Data()[j];
						counter++;
					}
					        		    						
	    		break;
				case Column::Int16 :
					cout << "Int16 " << endl;
					if (l == 0)
						{
							counter=0;
							colTest = tab->addColumn(col->name(), Column::Int16,"int16 data","");
							testData = colTest->data();
							int16Dat =  testData->int16Data();
							cout << "Column " << col->name() << " added" << endl;
						}
						
						if (l==0)
							for (unsigned int j = 0 ; j < col->rows() ; j++)
							{    				    				
								int16Dat[counter] = colData->int16Data()[j];
								counter++;
							}
					
						for (unsigned int j = 0 ; j < col2->rows() ; j++)
						{
							int16Dat[counter] = col2Data->int16Data()[j];
							counter++;
						}	 									
	    		break;
				case Column::Int32  :
					cout << "Int32 " << endl;
					if (l == 0)
						{
							counter=0;
							colTest = tab->addColumn(col->name(), Column::Int32,"int32 data","");
							testData = colTest->data();
							int32Dat =  testData->int32Data();
							cout << "Column " << col->name() << " added" << endl;
						}
						
						if (l==0)
							for (unsigned int j = 0 ; j < col->rows() ; j++)
							{    				    				
								int32Dat[counter] = colData->int32Data()[j];
								counter++;
							}
					
						for (unsigned int j = 0 ; j < col2->rows() ; j++)
						{
							int32Dat[counter] = col2Data->int32Data()[j];
							counter++;
						}	 						
	    		break;
				case Column::Uint32 :
					cout << "Uint32 " << endl;					   								
				
					if (l == 0)
					{
						counter=0;
						colTest = tab->addColumn(col->name(), Column::Uint32,"uint data","");
						testData = colTest->data();
						uint32Dat =  testData->uint32Data();
						cout << "Column " << col->name() << " added" << endl;
					}
					
					if (l==0)
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{    				    				
							uint32Dat[counter] = colData->uint32Data()[j];
							counter++;
						}
				
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{
						uint32Dat[counter] = col2Data->uint32Data()[j];
						counter++;
					}	 					    								    				
	    		break;
				case Column::Real32 :
					cout << "Real32 " << endl;
					
					if (l == 0)
					{	
						counter=0;
						colTest = tab->addColumn(col->name(), Column::Real32,"real32 data","");
						testData = colTest->data();
						real32Dat =  testData->real32Data();
						cout << "Column " << col->name() << " added" << endl;
					}		
					
					if (l==0)		
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{    				    				
							real32Dat[counter]= colData->real32Data()[j];
							counter++;
						}
					
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{						
						real32Dat[counter]= col2Data->real32Data()[j];
						counter++;
					}	    										
									    		
	    		break;
				case Column::Real64 :
					cout << "Real64 " << endl;
					if (l == 0)
					{	
						counter=0;
						colTest = tab->addColumn(col->name(), Column::Real64,"real64 data","");
						testData = colTest->data();
						real64Dat =  testData->real64Data();
						cout << "Column " << col->name() << " added" << endl;
					}		
					
					if (l==0)		
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{    				    				
							real64Dat[counter]= colData->real64Data()[j];
							counter++;
						}
					
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{						
						real64Dat[counter]= col2Data->real64Data()[j];
						counter++;
					}	    						
	    		break;
	    		
	    		case Column::DString :    
	    			cout << "String " << endl;	
	    			
	    			if (l == 0 )			    				    				
						for (unsigned int j = 0 ; j < col->rows() ; j++)
						{
							if (CalOalUtility::stringColumnRow(colData, j).length() > stringMax.length())
								stringMax=CalOalUtility::stringColumnRow(colData, j);
							
							stringVec.push_back(CalOalUtility::stringColumnRow(colData, j));
						}
						
					for (unsigned int j = 0 ; j < col2->rows() ; j++)
					{
						if (CalOalUtility::stringColumnRow(col2Data, j).length() > stringMax.length())
							stringMax=CalOalUtility::stringColumnRow(colData, j);
							
						stringVec.push_back(CalOalUtility::stringColumnRow(col2Data, j));
					}   

				 	lv[0] = stringMax.length();

					if (l == pfhfiles.size() -1)
					{	
						colTest = tab->addColumn(col->name(), Dal::DString,"string data",col->units(),lv);						
						testData = colTest->data();
						
						for (unsigned int k = 0 ; k < stringVec.size() ; k++)																						
							CalOalUtility::stringColumnRowSet(testData, k, stringVec[k]);											
						cout << "Column " << col->name() << " added" << endl;
					}
	
				break;
				
				default :
				break;    				
			    
			}//Switch
			obsEndAttr = tempTable->attribute("DATE-END")->asString();  
			
			delete col2Data;			
			dataSetServer->close(rgsTempDS);					
		}//Files loop	
		delete testData;
		delete colData;			
	}//Columns loop
	
	cout << "adding param" << endl;
	tab->addAttribute( oriTable->attribute("EXTVER") );
	tab->addAttribute( oriTable->attribute("TELESCOPE") );
	tab->addAttribute( oriTable->attribute("INSTRUMEN") );
	tab->addAttribute( oriTable->attribute("DATATYPE") );
	if (oriTable->hasAttribute("OBS_ID"))
		tab->addAttribute( oriTable->attribute("OBS_ID") );
	if (oriTable->hasAttribute("EXP_ID"))
		tab->addAttribute( oriTable->attribute("EXP_ID") );
	tab->addAttribute( oriTable->attribute("DATE-OBS") );
	cout << "adding param " << obsEndAttr<< endl;
	
	*tab->addAttribute("DATE_END","Exposure end time","") = obsEndAttr;
	cout << "closing files"<< endl;
	
	dataSetServer->close(newDS);	

	dataSetServer->close(rgsOriginalDS);		
	

ENDPROC
}
